<?php
//
// +----------------------------------------------------------------------+
// |zen-cart Open Source E-commerce                                       |
// +----------------------------------------------------------------------+
// | Copyright (c) 2003 The zen-cart developers                           |
// |                                                                      |
// | http://www.zen-cart.com/index.php                                    |
// |                                                                      |
// | Portions Copyright (c) 2003 osCommerce                               |
// |                                                                      |
// |   DevosC, Developing open source Code                                |
// |   Copyright (c) 2004 DevosC.com                                      |
// +----------------------------------------------------------------------+
// | This source file is subject to version 2.0 of the GPL license,       |
// | that is bundled with this package in the file LICENSE, and is        |
// | available through the world-wide-web at the following url:           |
// | http://www.zen-cart.com/license/2_0.txt.                             |
// | If you did not receive a copy of the zen-cart license and are unable |
// | to obtain it through the world-wide-web, please send a note to       |
// | license@zen-cart.com so we can mail you a copy immediately.          |
// +----------------------------------------------------------------------+
//  $Id: zhifubao.php 030 2006-08-12 Jack $
//

 class zhifubao {
   var $code, $title, $description, $enabled;

// class constructor
   function zhifubao($zhifubao_atn_id = '') {
     global $order;
       $this->code = 'zhifubao';
    if ($_GET['main_page'] != '') {
       $this->title = MODULE_PAYMENT_ZHIFUBAO_TEXT_CATALOG_TITLE; // Payment Module title in Catalog
    } else {
       $this->title = MODULE_PAYMENT_ZHIFUBAO_TEXT_ADMIN_TITLE; // Payment Module title in Admin
    }
       $this->description = MODULE_PAYMENT_ZHIFUBAO_TEXT_DESCRIPTION;
       $this->sort_order = MODULE_PAYMENT_ZHIFUBAO_SORT_ORDER;
       $this->enabled = ((MODULE_PAYMENT_ZHIFUBAO_STATUS == 'True') ? true : false);
       if ((int)MODULE_PAYMENT_ZHIFUBAO_ORDER_STATUS_ID > 0) {
         $this->order_status = MODULE_PAYMENT_ZHIFUBAO_ORDER_STATUS_ID;
       }
       if (is_object($order)) $this->update_status();
       $this->form_action_url = 'https://www.alipay.com/cooperate/gateway.do';
   }

// class methods
   function update_status() {
     global $order, $db;

     if ( ($this->enabled == true) && ((int)MODULE_PAYMENT_ZHIFUBAO_ZONE > 0) ) {
       $check_flag = false;
       $check_query = $db->Execute("select zone_id from " . TABLE_ZONES_TO_GEO_ZONES . " where geo_zone_id = '" . MODULE_PAYMENT_ZHIFUBAO_ZONE . "' and zone_country_id = '" . $order->billing['country']['id'] . "' order by zone_id");
       while (!$check_query->EOF) {
         if ($check_query->fields['zone_id'] < 1) {
           $check_flag = true;
           break;
         } elseif ($check_query->fields['zone_id'] == $order->billing['zone_id']) {
           $check_flag = true;
           break;
         }
                 $check_query->MoveNext();
       }

       if ($check_flag == false) {
         $this->enabled = false;
       }
     }
   }

   function javascript_validation() {
     return false;
   }

   function selection() {
     return array('id' => $this->code,
                  'module' => $this->title);
   }

   function pre_confirmation_check() {
     return false;
   }

   function confirmation() {
      return array('title' => MODULE_PAYMENT_ZHIFUBAO_TEXT_DESCRIPTION);
   }

   function process_button() {
     global $db, $order, $currencies;

     // save the session stuff permanently in case zhifubao loses the session
//     $db->Execute("delete from " . TABLE_ZHIFUBAO_SESSION . " where session_id = '" . session_id() . "'");

     $sql = "insert into " . TABLE_ZHIFUBAO_SESSION . " (session_id, saved_session, expiry) values (
            '" . session_id() . "',
            '" . base64_encode(serialize($_SESSION)) . "',
            '" . (time() + (1*60*60*24*2)) . "')";

     $db->Execute($sql);
     $last_unique_id = $db->Execute("select * from " . TABLE_ZHIFUBAO_SESSION . " order by unique_id desc limit 1");
     $zhifubao_out_trade_no = 'zenid=' . $last_unique_id->fields['unique_id'];

     $zhifubao_currency = 'CNY';
     $telephone = preg_replace('/\D/', '', $order->customer['telephone']);

     $zhifubao_body = '';
     for ($i=0; $i<sizeof($order->products); $i++) {
        $zhifubao_body = $order->products[$i]["name"] . "+" . $zhifubao_body;
     }
     $zhifubao_body = substr($zhifubao_body,0,-1);
     if (strlen($zhifubao_body) < 250) {
        $zhifubao_body = substr($zhifubao_body,0,strlen($zhifubao_body));
     } else {
        $zhifubao_body = substr($zhifubao_body,250);
     }
     $zhifubao_body = preg_replace('/\n/','',$zhifubao_body); 

     $zhifubao_partner = MODULE_PAYMENT_ZHIFUBAO_PARTNER;
     $zhifubao_seller_email = MODULE_PAYMENT_ZHIFUBAO_SELLER;
     $zhifubao_service = 'trade_create_by_buyer';
     $zhifubao_agent = '2088002197086652';
     $zhifubao_notify_url = zen_href_link('atn_main_handler.php', '', 'SSL',false,false,true);
     $zhifubao_return_url = zen_href_link(FILENAME_CHECKOUT_PROCESS, '', 'SSL');

     $zhifubao_subject = STORE_NAME . 'Ʒ';
     $zhifubao_price = number_format($order->info['total'] * $currencies->get_value($zhifubao_currency), $currencies->get_decimal_places($zhifubao_currency),'.','');

     $zhifubao_show_url = zen_href_link(FILENAME_DEFAULT, '', 'SSL');
     $zhifubao_quantity = '1';
     $zhifubao_payment_type = '1';

     $zhifubao_logistics_type = 'EXPRESS';
     $zhifubao_logistics_fee = '0.00';
     $zhifubao_logistics_payment = 'BUYER_PAY';

     $zhifubao_receive_name = $order->customer['lastname'] . $order->customer['firstname'];
     $zhifubao_receive_address = $order->customer['state'] . $order->customer['city'] . $order->customer['street_address'];
     $zhifubao_receive_zip = $order->customer['postcode'];

     $request_string = '_input_charset='    . 'GBK'                       . '&' .
                       'agent='             . $zhifubao_agent             . '&' .
                       'body='              . $zhifubao_body              . '&' .
                       'logistics_fee='     . $zhifubao_logistics_fee     . '&' .
                       'logistics_payment=' . $zhifubao_logistics_payment . '&' .
                       'logistics_type='    . $zhifubao_logistics_type    . '&' .
                       'notify_url='        . $zhifubao_notify_url        . '&' .
                       'out_trade_no='      . $zhifubao_out_trade_no      . '&' .
                       'partner='           . $zhifubao_partner           . '&' .
                       'payment_type='      . $zhifubao_payment_type      . '&' .
                       'price='             . $zhifubao_price             . '&' .
                       'quantity='          . $zhifubao_quantity          . '&' .
                       'receive_address='   . $zhifubao_receive_address   . '&' .
                       'receive_name='      . $zhifubao_receive_name      . '&' .
                       'receive_zip='       . $zhifubao_receive_zip       . '&' .
                       'return_url='        . $zhifubao_return_url        . '&' .
                       'seller_email='      . $zhifubao_seller_email      . '&' .
                       'service='           . $zhifubao_service           . '&' .
                       'show_url='          . $zhifubao_show_url          . '&' .
                       'subject='           . $zhifubao_subject . MODULE_PAYMENT_ZHIFUBAO_MD5KEY ;

     $process_button_string = zen_draw_hidden_field('_input_charset', 'GBK') .
     	                      zen_draw_hidden_field('agent', $zhifubao_agent) .
                              zen_draw_hidden_field('body', $zhifubao_body) .
                              zen_draw_hidden_field('logistics_fee', $zhifubao_logistics_fee) .
                              zen_draw_hidden_field('logistics_payment', $zhifubao_logistics_payment) . 
                              zen_draw_hidden_field('logistics_type', $zhifubao_logistics_type) .
                              zen_draw_hidden_field('notify_url', $zhifubao_notify_url) .
                              zen_draw_hidden_field('out_trade_no', $zhifubao_out_trade_no) .
                              zen_draw_hidden_field('partner', $zhifubao_partner) .
                              zen_draw_hidden_field('payment_type', $zhifubao_payment_type) .
                              zen_draw_hidden_field('price', $zhifubao_price) .
                              zen_draw_hidden_field('quantity', $zhifubao_quantity) .
                              zen_draw_hidden_field('receive_address', $zhifubao_receive_address) .
                              zen_draw_hidden_field('receive_name', $zhifubao_receive_name) .
                              zen_draw_hidden_field('receive_zip', $zhifubao_receive_zip) .
                              zen_draw_hidden_field('return_url', $zhifubao_return_url) .
                              zen_draw_hidden_field('seller_email', $zhifubao_seller_email) .
                              zen_draw_hidden_field('service', $zhifubao_service) .
                              zen_draw_hidden_field('show_url', $zhifubao_show_url) .
                              zen_draw_hidden_field('subject', $zhifubao_subject) .
                              zen_draw_hidden_field('sign', md5($request_string)) . 
                              zen_draw_hidden_field('sign_type', 'MD5');

     return $process_button_string;
   }

   function before_process() {
     global $order_total_modules;
    if (MODULE_PAYMENT_ZHIFUBAO_ATN_DEBUG == 'Yes') mail(MODULE_PAYMENT_ZHIFUBAO_DEBUG_EMAIL_ADDRESS,'֧֪ͨϢ', 'ͻ̵');

      $_SESSION['cart']->reset(true);
      unset($_SESSION['sendto']);
      unset($_SESSION['billto']);
      unset($_SESSION['shipping']);
      unset($_SESSION['payment']);
      unset($_SESSION['comments']);
      $order_total_modules->clear_posts();//ICW ADDED FOR CREDIT CLASS SYSTEM
      zen_redirect(zen_href_link(FILENAME_CHECKOUT_SUCCESS, '', 'SSL'));
   }

   function check_referrer($zf_domain) {
     return true;
   }

   function admin_notification($zf_order_id) {
     global $db;

     $sql = "select * from " . TABLE_ZHIFUBAO . " where zen_order_id = '" . $zf_order_id . "'";
     $atn = $db->Execute($sql);
     require(DIR_FS_CATALOG. DIR_WS_MODULES . 'payment/zhifubao/zhifubao_admin_notification.php');
     return $output;
   }

   function after_process() {
     $_SESSION['order_created'] = '';
     return false;
   }

   function output_error() {
     return false;
   }

   function check() {
     global $db;
     if (!isset($this->_check)) {
       $check_query = $db->Execute("select configuration_value from " . TABLE_CONFIGURATION . " where configuration_key = 'MODULE_PAYMENT_ZHIFUBAO_STATUS'");
       $this->_check = $check_query->RecordCount();
     }
     return $this->_check;
   }

   function install() {
     global $db;
     $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('֧֧ģ', 'MODULE_PAYMENT_ZHIFUBAO_STATUS', 'True', 'Ҫʹ֧֧ʽ?', '6', '0', 'zen_cfg_select_option(array(\'True\', \'False\'), ', now())");
     $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('email', 'MODULE_PAYMENT_ZHIFUBAO_SELLER','".STORE_OWNER_EMAIL_ADDRESS."', '֧ʺŵĵʼַ', '6', '2', now())");
      $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('ȫУ', 'MODULE_PAYMENT_ZHIFUBAO_MD5KEY', '뽻װȫУ', '˻ĽװȫУ룬עⱣ', '6', '4', now())");
      $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('ID', 'MODULE_PAYMENT_ZHIFUBAO_PARTNER', 'ID', '˻ĺID', '6', '5', now())");
     $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, use_function, set_function, date_added) values ('', 'MODULE_PAYMENT_ZHIFUBAO_ZONE', '0', 'ѡ˸õʹø֧ģ顣', '6', '6', 'zen_get_zone_class_title', 'zen_cfg_pull_down_zone_classes(', now())");
     $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, use_function, date_added) values ('֪ͨ״̬', 'MODULE_PAYMENT_ZHIFUBAO_PROCESSING_STATUS_ID', '2', 'ÿͻɵĶ״̬<br />(Ƽ״̬\'\')', '6', '8', 'zen_cfg_pull_down_order_statuses(', 'zen_get_order_status_name', now())");
     $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, use_function, date_added) values ('ö״̬', 'MODULE_PAYMENT_ZHIFUBAO_ORDER_STATUS_ID', '1', 'ò֧Ķ״̬<br />(Ƽ״̬\'ȴ\')', '6', '10', 'zen_cfg_pull_down_order_statuses(', 'zen_get_order_status_name', now())");
     $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('ʾ˳', 'MODULE_PAYMENT_ZHIFUBAO_SORT_ORDER', '0', 'ʾ˳Сʾǰ', '6', '12', now())");
     $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Ϣ', 'MODULE_PAYMENT_ZHIFUBAO_ATN_DEBUG', 'No', 'ͨʼյϢ', '6', '14', 'zen_cfg_select_option(array(\'Yes\',\'No\'), ', now())");
     $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Եʼַ', 'MODULE_PAYMENT_ZHIFUBAO_DEBUG_EMAIL_ADDRESS','".STORE_OWNER_EMAIL_ADDRESS."', 'ڵ֧ĵʼַ', '6', '16', now())");
}

   function remove() {
     global $db;
     $db->Execute("delete from " . TABLE_CONFIGURATION . " where configuration_key LIKE  'MODULE_PAYMENT_ZHIFUBAO%'");
   }

   function keys() {
     return array(
         'MODULE_PAYMENT_ZHIFUBAO_STATUS',
         'MODULE_PAYMENT_ZHIFUBAO_SELLER',
         'MODULE_PAYMENT_ZHIFUBAO_MD5KEY',
         'MODULE_PAYMENT_ZHIFUBAO_PARTNER',
         'MODULE_PAYMENT_ZHIFUBAO_ZONE',
         'MODULE_PAYMENT_ZHIFUBAO_PROCESSING_STATUS_ID',
         'MODULE_PAYMENT_ZHIFUBAO_ORDER_STATUS_ID',
         'MODULE_PAYMENT_ZHIFUBAO_SORT_ORDER',
         'MODULE_PAYMENT_ZHIFUBAO_ATN_DEBUG',
         'MODULE_PAYMENT_ZHIFUBAO_DEBUG_EMAIL_ADDRESS'
         );
   }
 }
?>