<?php
/**
 * functions used by payment module class for Zhifubao ATN payment method
 *
 * @package paymentMethod
 * @copyright Copyright 2003-2005 Zen Cart Development Team
 * @copyright Portions Copyright 2003 osCommerce
 * @copyright Portions Copyright (c) 2004 DevosC.com
 * @license http://www.zen-cart.com/license/2_0.txt GNU Public License V2.0
 * @version $Id: zhifubao_functions.php 3048 2006-02-16 23:40:21Z wilt $
 */
  function atn_debug_email($message, $email_address = MODULE_PAYMENT_ZHIFUBAO_DEBUG_EMAIL_ADDRESS, $always_send = false) {
    if (MODULE_PAYMENT_ZHIFUBAO_ATN_DEBUG == 'Yes' || $always_send) {
      mail($email_address,'ATN DEBUG message', $message);
      atn_add_error_log($message);
    }
  }
  function atn_get_stored_session($session_stuff) {
    global $db;
    if (!is_array($session_stuff)) {
      atn_debug_email('ATN FATAL ERROR::Could not find custom variable in post, cannot re-create session'); 
      return false;
    }
    $sql = "select * from " . TABLE_ZHIFUBAO_SESSION . " where unique_id = '" . $session_stuff[1] . "'"; 
    $stored_session = $db->Execute($sql);
    if ($stored_session->recordCount() < 1) {
      atn_debug_email('ATN FATAL ERROR::Could not find stored session in DB, cannot re-create session'); 
      return false;
    }
    $_SESSION = unserialize(base64_decode($stored_session->fields['saved_session']));
    return true;
  }

  function atn_add_error_log($message) {
    $fp = @fopen('atn.log', 'a');
    @fwrite($fp, date('D M Y G:i') . ' -- ' . $message . "\n");
    @fclose($fp);
  }
  function atn_fopen($filename) {
    $response = '';
    $fp = fopen($filename,'rb');
    if ($fp) {
      $response = getRequestBodyContents($fp);
      @fclose($fp);
    }
    return $response;
  }
  function getRequestBodyContents(&$handle) {
    if ($handle) {
      while(!feof($handle)) {
        $line .= @fgets($handle, 1024);
      }
      return $line;
    }
    return false;
  }
?>