<?php
//
// +----------------------------------------------------------------------+
// |zen-cart Open Source E-commerce                                       |
// +----------------------------------------------------------------------+
// | Copyright (c) 2003 The zen-cart developers                           |
// |                                                                      |
// | http://www.zen-cart.com/index.php                                    |
// |                                                                      |
// | Portions Copyright (c) 2003 osCommerce                               |
// | Portions may be Copyright (c) 2004 DevosC.com                       |
// |                                                                      |
// +----------------------------------------------------------------------+
// | This source file is subject to version 2.0 of the GPL license,       |
// | that is bundled with this package in the file LICENSE, and is        |
// | available through the world-wide-web at the following url:           |
// | http://www.zen-cart.com/license/2_0.txt.                             |
// | If you did not receive a copy of the zen-cart license and are unable |
// | to obtain it through the world-wide-web, please send a note to       |
// | license@zen-cart.com so we can mail you a copy immediately.          |
// +----------------------------------------------------------------------+
//  $Id: atn_main_handler.php 001 2005-10-24 00:00:00 jack $
//
/**
 * require general zhifubao functions
 */
require('includes/modules/payment/zhifubao/zhifubao_functions.php');
/**
 * require custom zhifubao application_top.php
 */
require('includes/modules/payment/zhifubao/atn_application_top.php');
/**
 * require language defines
 */
if (!isset($_SESSION['language'])) $_SESSION['language'] = 'schinese';
if (file_exists(DIR_WS_LANGUAGES . $_SESSION['language'] . '/' . $template_dir_select . 'checkout_process.php')) {
  require(DIR_WS_LANGUAGES . $_SESSION['language'] . '/' . $template_dir_select . 'checkout_process.php');
} else {
  require(DIR_WS_LANGUAGES . $_SESSION['language'] . '/checkout_process.php');
}
//require('includes/languages/english/checkout_process.php');
atn_debug_email('֧');

$scheme = 'http://';
if (ENABLE_SSL == 'true') $scheme = 'http://';
//Parse url
$web=parse_url($scheme . 'notify.alipay.com/trade/notify_query.do?');

//build post string
$postdata = "partner=" . MODULE_PAYMENT_ZHIFUBAO_PARTNER . "&notify_id=" . $_POST["notify_id"];
if (ENABLE_SSL == 'true') $postdata = "service=notify_verify" ."&partner=" . MODULE_PAYMENT_ZHIFUBAO_PARTNER . "&notify_id=" . $_POST["notify_id"];

// $postdata.="cmd=_notify-validate";

// Set the port number
if($web['scheme'] == "https") {
   $web['port']="443"; $ssl="ssl://"; } else {
       $web['port']="80";
       $ssl="";
   }

//Create zhifubao connection
  $fp=@fsockopen($ssl . $web['host'],$web['port'],$errnum,$errstr,30);

  if(!$fp) {
    atn_debug_email('fsockopenʧ ' .  $ssl . $web['host'] . '#');
    die();
  }

//Post Data

   fputs($fp, "POST $web[path] HTTP/1.1\r\n");
   fputs($fp, "Host: $web[host]\r\n");
   fputs($fp, "Content-type: application/x-www-form-urlencoded\r\n");
   fputs($fp, "Content-length: ".strlen($postdata)."\r\n");
   fputs($fp, "Connection: close\r\n\r\n");
   fputs($fp, $postdata . "\r\n\r\n");

// loop through the response from the server
   while(!feof($fp)) {
     $info[]=@fgets($fp, 1024);
   }

// close fp - we are done with it
   fclose($fp);

// break up results into a string
   $info = implode(",",$info);

  atn_debug_email('˶MD5');

  while (list ($i, $v) = each ($_POST)) {
    if ($i == "sign" || $i == "sign_type" || $v == "") continue;
    else $zhifubao_para[$i] = $_POST[$i];
  }

  ksort($zhifubao_para);
  reset($zhifubao_para);

  $request_string = '';

  foreach ($zhifubao_para as $i=>$v) {
    $request_string .= $i . "=" . $v . "&";
  }
  $request_string = substr($request_string,0,count($request_string)-2) . MODULE_PAYMENT_ZHIFUBAO_MD5KEY;

  if (!(eregi("true$",$info) && ($_POST['sign'] == md5($request_string)) )) {
     atn_debug_email('޷֤ ' . '#' . $_POST['out_trade_no'] . '#' . $_POST['trade_status'] . '#' . $info . '#' . $request_string);
       die();
  }

/**
 * reaquire shipping class
 */
require(DIR_WS_CLASSES . 'shipping.php');
/**
 * require payment class
 */
require(DIR_WS_CLASSES . 'payment.php');
$payment_modules = new payment($_SESSION['payment']);
$shipping_modules = new shipping($_SESSION['shipping']);

/**
 * require order class
 */
require(DIR_WS_CLASSES . 'order.php');
$order = new order();
/**
 * require order_total class
 */
require(DIR_WS_CLASSES . 'order_total.php');
$order_total_modules = new order_total();
$order_totals = $order_total_modules->process();

  atn_debug_email('⽻׺ ' . '#'.$_POST['out_trade_no']);

  $zen_order_status = 0;
  $zen_status_desc = '';
  switch ( $_POST['trade_status'] ) {
  	case 'WAIT_BUYER_PAY':
  	  $zen_order_status = 1;
  	  $zen_status_desc = 'ȴҸ';
  	  break;
  	case 'WAIT_SELLER_CONFIRM_TRADE':
  	  $zen_order_status = 2;
  	  $zen_status_desc = 'Ѵȴȷ';
  	  break;
  	case 'WAIT_SYS_CONFIRM_PAY':
  	  $zen_order_status = 3;
  	  $zen_status_desc = 'ȷҸУ𷢻';
  	  break;
  	case 'WAIT_SELLER_SEND_GOODS':
  	  $zen_order_status = 4;
  	  $zen_status_desc = '֧յҸҷ';
  	  break;
  	case 'WAIT_BUYER_CONFIRM_GOODS':
  	  $zen_order_status = 5;
  	  $zen_status_desc = 'ѷȷ';
  	  break;
  	case 'WAIT_SYS_PAY_SELLER':
  	  $zen_order_status = 6;
  	  $zen_status_desc = 'ȷյȴ֧';
  	  break;
  	case 'TRADE_FINISHED':
  	  $zen_order_status = 7;
  	  $zen_status_desc = '׳ɹ';
  	  break;
  	case 'TRADE_CLOSED':
  	  $zen_order_status = 8;
  	  $zen_status_desc = ';ر';
  	  break;
  	default:
      $zen_order_status = 0;
      $zen_status_desc = '';
  }

// see if this is a existing order
  $zen_action = 'unknown';
  $sql = "select * from " . TABLE_ZHIFUBAO . " where out_trade_no = '" . $_POST['out_trade_no'] . "'";
  atn_debug_email('ʼtest_atn: ' . $sql);

  $test_atn = $db->Execute($sql);
  atn_debug_email('ͨtest_atn' . 'zen_order_status = ' . $zen_order_status . ' Count: ' . $test_atn->RecordCount());

  if ($zen_order_status>0) {
     if ($test_atn->RecordCount()>0) {
        $zen_action = 'update';
     } else {
        $zen_action = 'new';
     }
  }

  $test_order = $db->Execute("select orders_status from " . TABLE_ORDERS . " where orders_id = '" . $test_atn->fields['zen_order_id'] . "'");

  switch ($zen_action) {
    case 'new':
      atn_debug_email('');
      $new_order_id = $order->create($order_totals);

      $zhifubao_order = array('zen_order_id' => $new_order_id,
                              'trade_no' => $_POST['trade_no'],
                              'out_trade_no' => $_POST['out_trade_no'],
                              'notify_time' => $_POST['notify_time']);

      zen_db_perform(TABLE_ZHIFUBAO, $zhifubao_order);

      $insert_id = $db->Insert_ID();

      $zhifubao_order_history = array (
                                     'zhifubao_atn_id' => $insert_id,
                                     'trade_no' => $_POST['trade_no'],
                                     'out_trade_no' => $_POST['out_trade_no'],
                                     'trade_status' => $_POST['trade_status'],
                                     'notify_time' => $_POST['notify_time']
                                    );

      zen_db_perform(TABLE_ZHIFUBAO_PAYMENT_STATUS_HISTORY, $zhifubao_order_history);

      $new_status = MODULE_PAYMENT_ZHIFUBAO_PROCESSING_STATUS_ID;
      $sql_data_array = array('orders_id' => $new_order_id,
                          'orders_status_id' => $new_status,
                          'date_added' => 'now()',
                          'comments' => $zen_status_desc . ' @ ' . $_POST['notify_time'],
                          'customer_notified' => false
                          );

      zen_db_perform(TABLE_ORDERS_STATUS_HISTORY, $sql_data_array);
      $order->create_add_products($new_order_id, 2);
      atn_debug_email('ɶ');
      echo 'success';

      $order->send_order_email($new_order_id, 2);
      $_SESSION['cart']->reset(true);

      atn_debug_email('Emailɹ');

      break;
    case 'update':
      atn_debug_email('ʼ¶ʷ¼');

      $zhifubao_order_history = array (
                                 'zhifubao_atn_id' => $test_atn->fields['zhifubao_atn_id'],
                                 'trade_no' => $_POST['trade_no'],
                                 'out_trade_no' => $_POST['out_trade_no'],
                                 'trade_status' => $_POST['trade_status'],
                                 'notify_time' => $_POST['notify_time']
                                );

      $sql_data_array = array ('orders_id' => $test_atn->fields['zen_order_id'],
                      'orders_status_id' => $test_order->fields['orders_status'],
                      'date_added' => 'now()',
                      'comments' => $zen_status_desc . ' @ ' . $_POST['notify_time'],
                      'customer_notified' => false
                      );

          zen_db_perform(TABLE_ORDERS_STATUS_HISTORY, $sql_data_array);

          zen_db_perform(TABLE_ZHIFUBAO_PAYMENT_STATUS_HISTORY, $zhifubao_order_history);

          atn_debug_email('ɹ¶ʷ¼' );
          echo 'success';

        break;
    default:
      atn_debug_email('֪ͨ״̬δ֪ ' . '#'.$_POST['out_trade_no'].'#'.$_POST['trade_status'].'#');
  }

?>